% computing and storing "clean" frame differences
% Second (improved) attempt of motion detector

% path for input frames
%pathIn='C:\Documents and Settings\helalfy\My Documents\Research\Thumbnailing Frames\VS-Vid';
pathIn='C:\MunichVid\Scene2Cam3';
% path for output frames background subtracted
%pathOut='C:\Documents and Settings\helalfy\My Documents\Research\Thumbnailing Frames\VS-FrmDif';
pathOut='C:\MunichFrmDif\Scene2Cam3';
if isempty(dir(pathOut))
	mkdir(pathOut);     % create output directory if not existent
end

step=1;         % process every frame
diffstep=15;    % distance between subtracted frames
thr=0.1;        % threshold for frame difference (leave all "salt" noise)
idxstrt=9000; idxend=10999-diffstep;   % first and last frame indices
camera='Cam3-'; frmt='jpg';    % camera number and file format
SE=strel('diamond',2);      % structure element for opening (cleaning) frame difference
                            % size of strel depends on video resolution
SEcls=strel('diamond',15);  % structure element for closing gaps between blobs

tic
for ii=idxstrt : step : idxend
    fprintf('Processing frame %5d of %5d', ii,idxend)
    % read current, previous and next frames
    imfilenow=[pathIn '\' camera sprintf('%05d',ii) '.' frmt];     % current frame file name
    ffnow=imread(imfilenow); ffnow=double(rgb2gray(ffnow));        % current frame grayscaled
    imfilenext=[pathIn '\' camera sprintf('%05d',ii+diffstep) '.' frmt]; % next frame file name
    ffnext=imread(imfilenext); ffnext=double(rgb2gray(ffnext));        % next frame grayscaled
%     imfileprev=[pathIn '\' camera sprintf('%05d',ii-diffstep) '.' frmt]; % prev frame file name
%     ffprev=imread(imfileprev); ffprev=double(rgb2gray(ffprev));        % prev frame grayscaled
    % previous and next frame differences 'AND'ed
    diffbwNxt=im2bw(uint8(abs(ffnow-ffnext)),thr);       % next frame difference, thresholded
%     diffbwPrv=im2bw(uint8(abs(ffnow-ffprev)),thr);       % prev frame difference, thresholded
%     cleandiffbw=imopen(diffbwNxt&diffbwPrv,SE);      % open image (remove "salt" noise)
    cleandiffbw=imopen(diffbwNxt,SE);      % open image (remove "salt" noise)
    % my version of 'imclose' (keeps blobs same size vs. Matlab's)
    cleandiffbw=imdilate(cleandiffbw,SEcls);    % dilate to merge nearby blobs
    cleandiffbw=imerode(cleandiffbw,SEcls);     % erode to restore size
    expfile=[pathOut '\' camera sprintf('%05d',ii) '.png' ];   % output file name
    imwrite(cleandiffbw,expfile,'png');     % write PNG file (smallest size)
    fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b')
end
toc