% load first 'Prefixes_Long.mat' and 'Prefixes_Short.mat'
plot([1:1000]',AllPaths{5},'-k', [1:20]',AllShortPaths{1},'-*', ...
[1:40]',AllShortPaths{2},'-.', [1:60]',AllShortPaths{3},'--', ...
[1:80]',AllShortPaths{4},':', [1:100]',AllShortPaths{5},'-.')
xlim([1,100])
ylabel('window #'); xlabel('frame #'); set(gca,'XGrid','on')
legend('1000 frames', '20 frames', '40 frames', '60 frames', '80 frames', '100 frames')
% title('Shared prefixes for different segment lengths')
%========================================================================%
% histogram of 'last updated' property of vertices
% make a few 'BuildGraph' long runs and keep the V.updt matrices
counttot=1; diff=zeros(1,size(V.updt,2)*size(V.updt,1));
for countcol=1:size(V.updt,2)
    for countrow=1:size(V.updt,1)
        diff(counttot)=V.updt(countrow,countcol)-countcol;  % linearize column-wise
        counttot=counttot+1;
    end
end
nonupdt=find(diff<0);   % non-updated nodes
diff(nonupdt)=[];       % remove non-updated nodes
hist(diff)      % histogram of updated nodes
xlabel('last updated (frames ahead)'), ylabel('count (vertices)')
%========================================================================%
% script for several overlapping runs without video output
% length of run 200 ==> first and last segements will be 240
% and the others will be 280
nseg=5; seglen=200; ovl=40; AllSegments=cell(nseg+1,1);
dT=1000; offset=0; Visualize;   % reference segment of 1000 frames
AllSegments{1}=pathsmooth;
dT=seglen+ovl; offset=0; Visualize;  % first segment
AllSegments{2}=pathsmooth(1:seglen); %lastW=pathsmooth(seglen-ovl);
for segseg=2:nseg-1     % interior frames
    dT=seglen+2*ovl; offset=seglen*(segseg-1)-ovl; Visualize;
    AllSegments{segseg+1}=pathsmooth(1+ovl:end-ovl); %lastW=pathsmooth(seglen);
end
dT=seglen+ovl; offset=seglen*(nseg-1)-ovl; Visualize;  % last segment
AllSegments{nseg+1}=pathsmooth(1+ovl:end);
% Data saved in Segments20.mat. Load this file rather than running the
% above script
% Plotting window path
figure; plot([1:length(AllSegments{1})]', AllSegments{1}, '-r'); hold on;   % whole path
plot([1:length(AllSegments{2})]', AllSegments{2}, '-b') % first segment
for segseg=3:nseg+1     % remaining segments
    offoff=seglen*(segseg-2);
    plot(offoff+[1:length(AllSegments{segseg})]', AllSegments{segseg}, '-b')
end
set(gca,'XGrid','on')
legend('1000 frames', '200 frames')
xlabel('frame #'); ylabel('window #')
%========= video output for cut out overlaping frames
dT=seglen;
for segseg=1:nseg
    offset=seglen*(segseg-1); pathsmooth=AllSegments{segseg+1}; VidOut;
end
%========================================================================%
% Cost of 2 pathes: Load 'Pass1_2.mat'
costfrm1=zeros(1,1000); costfrm1(1)=cost1(1);
for coscos=2:1000, costfrm1(coscos)=cost1(coscos)-cost1(coscos-1); end
costfrm2=zeros(1,1000); costfrm2(1)=cost2(1);
for coscos=2:1000, costfrm2(coscos)=cost2(coscos)-cost2(coscos-1); end
plot([1:dT],costfrm1,'-r',  [1:dT],costfrm2,'--b'), ylim([30 105])
legend('Path I cost', 'Path II cost'), xlabel('frame #'),ylabel('cost function')
% no of frames where cost1 > cost2 [==> result 87/1000]
coscount=0; for coscos=1:dT
if costfrm1(coscos)>costfrm2(coscos), coscount=coscount+1; end, end
%========================================================================%
% Ratio of costs to determine cut-off ratio
for coscos=6:dT-10
costratio(coscos)=(cost2(coscos+10)-cost2(coscos-5))/(cost1(coscos+10)-cost1(coscos-5));
end
figure; hist(costratio);    figure; hist(1./costratio(6:990)); % by eye
% binary search with these
length(find(costratio<1.3))/length(costratio)*100; % [ans = 72.2222]
length(find(1./costratio(6:990)<1.0))/985*100; % [ans = 92.4873]
%========================================================================%
% Batch for several shortest pathes through video
% Update: 'pathIn', 'pathOut', 'pathFrm', 'camera' (but not 'pathWipe').
frame_diff;
BuildGraph; costs(1,:)=cost;  jjpixes(1,:)=jjpix;  iipixes(1,:)=iipix; sspixes(1,:)=sspix;
% ==> save here 'VinV' as it will get destroyed in the coming runs <==
save('MunichPathesCam2.mat', 'costs','jjpixes','iipixes')
clear GR V Stk; pack; pause(10)
for SP=2:3
    Visualize; costs(SP,:)=cost;  jjpixes(SP,:)=jjpix;  iipixes(SP,:)=iipix;
    sspixes(SP,:)=sspix;
    save('MunichPathesCam2.mat', 'costs','jjpixes','iipixes')
    clear GR V Stk; pack; pause(10)
end
VidOut
%========================================================================%
% Batch to combine 3 videos "vertically"
path1 = 'C:\MunichCrop\Scene2Cam1'; path2 = 'C:\MunichCrop\Scene2Cam2';
path3 = 'C:\MunichCrop\Scene2Cam3'; pathOut = 'C:\MunichCrop\Scene2Combine';
if isempty(dir(pathOut)), mkdir(pathOut);  end  % create output folder
frms1 = dir(path1); frms2 = dir(path2); frms3 = dir(path3);
nfrm = min([length(frms1), length(frms2), length(frms3)]);
% separator
imtmp1 = imread([path1 '\' frms1(3).name]);
blkline=zeros(4,size(imtmp1,2),3,'uint8');       % black line, thickness = 4 pixels
whtline=255*ones(4,size(imtmp1,2),3,'uint8');    % white line, thickness = 4 pixels
sep = [blkline;whtline;blkline];
% combine all frames
tic;
for ff = 3:nfrm      % skip the '.' and '..' directories
    fprintf('Processing frame %5d of %5d', ff,nfrm)
    imtmp1 = imread([path1 '\' frms1(ff).name]);
    imtmp2 = imread([path2 '\' frms2(ff).name]);
    imtmp3 = imread([path3 '\' frms3(ff).name]);    
    imtogo = [imtmp1;sep; imtmp2;sep; imtmp3];
    imwrite(imtogo, [pathOut '\Cam123-' sprintf('%05d',ff-2) '.jpg'], 'jpg');
    fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b')
end
toc
%========================================================================%
% batch to plot segments in the trap. Load "SegmentsTrap.mat"
figure; plot([6751:20:7050],jjpix150(1:20:end),'--xb', [6441:2:7440],jjpix500(1:2:end),'r')
hold on; plot([6651:2:7050],jjpix200a(1:2:end),'--g', [6851:2:7250],jjpix200b(1:2:end),'--g')
plot([6751:2:7050],300-3*costfrm150,'--m', [6441:2:7440],300-3*costfrm500,'k')
ylim([-5,300]), xlabel('frame #'), set(gca,'XGrid','on')
legend('150-segment', '500-segment', '200-segment A', '200-segment B', '150-Energy', '500-Energy')
% a cleaner version below
figure, plot([6441:2:7440],jjpix500(1:2:end),'r'), hold on;
plot([6651:2:7050],jjpix200a(1:2:end),'--b', [6851:2:7250],jjpix200b(1:2:end),'--b')
plot([6441:2:7440],300-3*costfrm500,'k')
legend('1000-frame segment', '400-frame segment A', '400-frame segment B', 'Energy')
ylim([-5,300]), xlabel('frame #'), set(gca,'XGrid','on')
%========================================================================%
% batch to compare the performance of regualar Dijkstra algorithm and Dial
% implementation. The run times have been stored in 'treg' (Dijkstra) and
% 'thash' (Dial)
xf      = [25 50 75 100 125 150 175 200];
treg    = [109 262 409 505 530 735 1009 1165];
thash   = [67 125 191 258 316 385 435 508];
preg    = polyfit(xf,treg,2);	% 2nd order polynomial fitting (least squares)
phash   = polyfit(xf,thash,1);	% linear regression (least squares)
conti   = [0:225];
freg    = polyval(preg,conti);	% evaluate polynomials
fhash   = polyval(phash,conti);
plot(xf,treg,'o', xf,thash,'*',  conti,freg,'-', conti,fhash,'--');
legend('Dijkstra', 'Dial'), xlabel('frames processed'), ylabel('run time (sec)')
% I also tried linear regression with treg but got a larger error than
% quadratic
% preg2 = polyfit(xf,treg,1); freg2 = polyval(preg2,conti);
% hold, plot(conti,freg2,':')
% freg2dis    = polyval(preg2,xf);
% freg1dis    = polyval(preg,xf);
% >> sum(abs(freg2dis-treg))        % |error| using linear regression
% ans =
%   436.2143
% >> sum(abs(freg1dis-treg))        % |error| using quadratic regression
% ans =
%   342.9524
%========================================================================%
% video cropper: crops from right side of the video
pathIn = 'C:\Documents and Settings\helalfy\My Documents\Research\Thumbnailing\ACMMM07\Oral Presentation\tempsmooth';
pathOut = 'C:\Documents and Settings\helalfy\My Documents\Research\Thumbnailing\ACMMM07\Oral Presentation\tempsmooth\out';
if isempty(dir(pathOut)), mkdir(pathOut);  end  % create output folder
frms = dir(pathIn); nfrm = length(frms);
tic;
for ff = 4:nfrm      % skip the '.' and '..' directories and 'out' subdirectory
    fprintf('Processing frame %5d of %5d', ff,nfrm)
    imtmp = imread([pathIn '\' frms(ff).name]);
    imtogo = imtmp(:,1:320,:);
    imwrite(imtogo, [pathOut '\traffic01-' sprintf('%05d',ff-2) '.jpg'], 'jpg');
    fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b')
end
toc
